import os, sys, optparse, random
import numpy as np
import matplotlib
from matplotlib import pyplot as plt
import xml.etree.ElementTree as ET
import xlwt
from xlwt import Workbook

if 'SUMO_HOME' in os.environ:
    tools = os.path.join(os.environ['SUMO_HOME'], 'tools')
    sys.path.append(tools)
else:
    sys.exit("please declare environment variable 'SUMO_HOME'")
from sumolib import checkBinary #noqa
import traci #noqa

def run():
    """execute the TraCI control loop"""
    step = 0
    n=0
    i=0
    d=0
    """Get list of routes"""
    listroute=traci.route.getIDList()
    #while traci.simulation.getMinExpectedNumber() > 0:
            
    """Choose random route"""
    #routename=random.choice(listroute)
        
    """Adding vehicle"""
    for a in range(0,18,1):
        veh_id='vehicle_%s' %(i)
        routename=random.choice(listroute)
        listedges=traci.route.getEdges(routename)    
        traci.vehicle.add(veh_id,routename)
        if "-gneE11" in listedges:
            traci.vehicle.rerouteParkingArea(veh_id,"ACAD37")
        i+=1
    while step < 32400:
        traci.simulationStep()
            
        """To get number of vehicles"""
        arrival=traci.simulation.getArrivedNumber()
        n=n+arrival
        step += 1
    print(listedges)

def get_options():
    optParser = optparse.OptionParser()
    optParser.add_option("--nogui", action="store_true",
                         default=False, help="run the commandline version of sumo")
    options, args = optParser.parse_args()
    return options

# this is the main entry point of this script
if __name__ == "__main__":
    options = get_options()

    # this script has been called from the command line. It will start sumo as a
    # server, then connect and run
    if options.nogui:
        sumoBinary = checkBinary('sumo')
    else:
        sumoBinary = checkBinary('sumo-gui')
    # this is the normal way of using traci. sumo is started as a
    # subprocess and then the python script connects and runs
    traci.start([sumoBinary, "-c", "config.sumocfg",
                             "--tripinfo-output", "tripinfo.xml"])
    run()
